#include "crasm86.inc"

;IPwizard v1.3
;converts IP numbers to decimal from binary, and vice-versa.
;by Cassady Roop
;SImmoralTech Software

dynamic_data	equ	$EAD0				;_asm_exec_ram+5000 (for changing data)
class		equ	dynamic_data+0			;stores IP class
binary_answer	equ	dynamic_data+1		;stores the answer as an 8-byte text string, z-terminated
num_spot		equ	dynamic_data+9		;three bytes and a zero-termination used by AtoDEC


.org _asm_exec_ram

	call _runindicoff
	call _flushallmenus
	xor a
	ld (binary_answer+8), a		;make sure the answer string is zero-terminated
	jr dec_to_bin				;start out in the dec->bin mode	

doTitle:						;clear screen, print title
	call _clrlcd
	call makemenu				;make the menu at bottom of screen
	ld hl, $0000
	ld (_pencol), hl
	ld hl, Titletext
	call _vputs								;'IPwizard 1.0'
	ld hl, $004B
	ld (_pencol), hl
	ld hl, credittext
	call _vputs								;'by Cassady Roop'
	call drawBox
	ld hl, $FC70							;put a line at (row6 * 16)+FC00
	ld b, 16								;16 bytes in a row
LineLoop:
	ld (hl), $FF			;darken 8 pixels
	inc hl					;next byte in vidmem
	djnz LineLoop			;recycle until line is complete
	ret
	


dec_to_bin:									;handles decimal to binary conversion
	call textblank
	call doTitle
	ld hl, $0902
	ld (_pencol), hl
	ld a, 'D'
	call _vputmap								;make mode indicator
	ld hl, $100D
	ld (_pencol), hl
	ld hl, IPtext							;'IP:'
	call _vputs
	
	ld hl, $1800
	ld (_pencol),hl							;pen location
	ld hl, $0402							;cursor location
	ld (_currow),hl
	ld c, 0									;clear c, the counter
decEnterLoop:
	inc c									;increment counter
	set curAble, (IY+curFlags)				;cursor on
	call getDig								;get <=3 digit num, store to b
	ld a, c
	cp 1									;first loop?
	jp nz, decDisp_it							;if not, class already done
	ld a, b									;put input number into a
	call findClass							;input num in a, output class char in (class)	
	ld hl, (_pencol)
	push hl									;save coords
	ld hl, $1E5A
	ld (_pencol), hl
	ld hl, classtext						;'Class'
	call _vputs
	ld hl, (_pencol)
	inc (hl)								;increment column
	ld a, (class)
	call _vputmap							;display class
	pop hl
	ld (_pencol), hl						;recall coords
decDisp_it:
	call make_binary						;convert
	call newVline							;new vWidth line
	ld hl, binary_answer					;binary answer in char codes
	call _vputs								;coords already loaded
	ld a, c									;put counter into a
	cp 4									;fourth loop complete?
	jp z, inputDone							;then done with input
	ld a, '.'								;going to separate numbers with a dot
	call _putc							;hopefully advances pen location
	call _vputmap								;put it and inc cursor location
	jp decEnterLoop							;do it all again
inputdone:
	res curable, (IY+curflags)			;disable cursor
EndKeyLoop:
	call _getkey
	cp kF1
	jp z, dec_to_bin
	cp kF2
	jp z, bin_to_dec
	cp kF5
	jp z, quit
	jr endkeyloop



findClass:									;input number in a, find IP class, output char in (class)
	sub 128									;is it 127 or less?
	jp m, class_a							;if negative then class A
	sub 64									;is it 192 or less?
	jp M, class_b							;if negative then class B
	sub 32									;is it 223 or less?
	jp M, class_c							;if negative then class C
	sub 24									;is it 247 or less?
	jp M, class_d							;if negative then class D
	jr class_e
class_a:
	ld a, 65
	ld (class), a							;char code for 'A'
	ret
class_b:
	ld a, 66
	ld (class), a							;char code for 'B'
	ret
class_c:
	ld a, 67
	ld (class), a							;char code for 'C'
	ret
class_d:
	ld a, 68
	ld (class), a							;char code for 'D'
	ret
class_e:
	ld a, 69
	ld (class), a							;char code for 'E'
	ret





drawBox:									;draw box around mode indicator
	ld hl, $FC80							;start of row 8
	ld (hl), $FE
	ld hl, $FC80							;row 8
	ld b, 7									;b rows of the following:
	ld de, $0010							;one row's worth of bytes
drawboxleft:								;draw the right side of the box
	add hl, de								;next row
	ld (hl), %10000010						;draw bit 7, bit 2 dark, others light
	djnz drawboxleft						
	ld hl, $FC80							
	ld b, 7
drawboxbottom:								;draw bottom side
	ld hl, $FCF0
	ld (hl), $FE
	ret										;done
	
makemenu:									;draw menu
	ld hl, $FF80			;start byte of row 56 in video mem
	ld b, 32					;initialize counter
HLineLoop:
	ld (hl), $FF				;darken 8 pixels
	inc hl					;next byte
	djnz HLineLoop			;recycle
	ld hl, $FFA0			;vidmem, first byte of row 58
	ld b, 6					;initialize line counter
	ld de, $0003
VLineLoop:
	ld a, %11000000
	ld (hl), a				;move to vidmem
	add hl, de				;HL+3=HL
	ld (hl), a				;uses same byte as last one
	add hl, de
	ld (hl), %01100000
	add hl, de
	ld (hl), %00011000
	add hl, de
	ld (hl), %00001100
	add hl, de
	ld (hl), %00000110
	inc hl					;next line
	djnz VLineLoop			;if not done, recycle
	ld hl, $FF8F
	ld a, %11111110				;remove unsightly piece of overshot
	ld (hl), a
	ld hl, $FF9F
	ld (hl), a
	ld hl, $3A03
	ld (_pencol), hl
	ld hl, dectobintext
	call _vputs					;'DEC>B'
	ld hl, $3A1C
	ld (_pencol), hl
	ld hl, bintodectext
	call _vputs					;'BIN>D'
	ld hl, $3A6A
	ld (_pencol), hl
	ld hl, quittext
	call _vputs					;'Quit'
	ret




getDig:         							; B = number output
	call keydiscrim							; get control and numeric keys only
	cp kenter
	jr z, getDig							;disallow enter key on first input cycle
	push af									;save keycode
	add a, 20								;get char code from _getkey code
	call _putc								;display char
	pop af									;recall keycode
	sub k0    							    ; subtract getkey value
	ld b,a      							; save value
	call keydiscrim 						; next digit
	cp kEnter  								; enter pressed?
	ret z        							; then we're done
	push af									;save
	add a, 20								;get char code
	call _putc							;display char
	pop af									;recall
	sub k0  							    ; subtract value
	ld d,a       							; save keypress
	call getDigM 							; multiply current number by 10
	add a,d      							; add new number
	ld b,a      							; save it
	call keydiscrim							; next digit
	cp kEnter   							; enter pressed?
	ret z      							    ; then we're done
	push af									;save
	add a, 20								;get char code
	call _putc							;display char
	pop af									;recall
	sub k0       							; subtract value
	ld d,a   							    ; save keypress
	call getDigM 							; multiply curr number by 10
	add a,d     							; add new number
	ld b,a 							        ; save it
	ret         							; we're done
getDigM:
	ld a,b 							        ; get num
	rlca       								; * 2
	ld b,a       							; save * 2
	rlca      								; * 4
	rlca        							; * 8
	add a,b      							; *2 + *8 = * 10
	ret         							; back to input
keydiscrim:
	push hl
	call _getkey
	pop hl
	cp kenter
	ret z
	cp kF1
	jr z, getDigdtob
	cp kF2
	jr z, getDigbtod
	cp kF5
	jr z, getDigquit
	cp $1C						;is it below numeric range?
	jp m, keydiscrim
	cp $26						;is it above numeric range?
	jp p, keydiscrim
	ret
getDigdtob:
	pop bc
	pop bc								;this was called
	jp dec_to_bin						;restart current mode
getDigbtod:
	pop bc
	pop bc								;this was called
	jp bin_to_dec						;switch mode
getDigquit:
	pop bc
	pop bc
	jp quit
	


make_binary:
	ld d,b								;number to disp in binary
	ld hl, binary_answer-1				;load just before temp area
	ld b,8								;initiate counter register
shiftcycle:
	rl d								;shift left; bit 0 --> carry flag
	jr c, place_one						;is bit a one?
	inc hl								;else inc temp area pointer
	ld (hl),48							;load char. code for '0'
	djnz shiftcycle						
	ret
place_one:
	inc hl								;inc temp pointer
	ld (hl),49							;load char. code for '1'
	djnz shiftcycle						;if not done then re-loop
	ret


newVline:								;new vWidth line
	ld hl, (_pencol)
	ld l, 0
	ld a, h
	add a, 6
	ld h, a
	ld (_pencol), hl
	ret	


textblank:						;erases _textshadow	
	ld hl, _textShadow
	ld b, 105
blankloop:						;fills _textShadow with space chars so it won't interfere with cursor
	ld (hl), 32					;space char
	inc hl
	djnz blankloop				;until string is spaced to b characters
	ret



Bin_to_dec:							;mode 2
	call textblank
	call doTitle
	ld hl, $0902
	ld (_pencol), hl
	ld a, 'B'
	call _vputmap								;make mode indicator
	ld hl, $1001
	ld (_pencol), hl
	ld hl, iptext
	call _vputs						;'IP:'
	ld hl, $0202
	ld (_currow), hl
	call _cursoron					;turn on cursor
	ld hl, $2800
	ld (_pencol), hl
	call binInput					;get input and disp
	push af
	call findclass					;determine IP class
	pop af
	call AtoDEC						;create decimal result and disp
	ld a, '.'
	call _putc						;dot the binary
	call _vputmap					;dot the decimal
	
	ld hl, (_pencol)				;display the IP class
	push hl									;save coords
	ld hl, $285A
	ld (_pencol), hl
	ld hl, classtext						;'Class'
	call _vputs
	ld hl, (_pencol)
	inc (hl)								;increment column
	ld a, (class)
	call _vputmap							;display class
	pop hl
	ld (_pencol), hl						;recall coords

	call binInput
	call AtoDEC
	ld a, '.'
	call _vputmap
	ld hl, $0203
	ld (_currow), hl
	call binInput
	call AtoDEC
	ld a, '.'
	call _putc
	call _vputmap
	call binInput
	call AtoDEC
	call _cursoroff
	jp EndKeyLoop					;done with task.



binInput:
	ld b, 8
	ld hl, $FA00						;tempstorage
binInputloop:								;input in ones and zeroes
	call keydiscrim						;get acceptable input or jump elsewhere according to Fkeys
	cp kenter
	jr z, binInputloop						;enter key not accepted
	cp k1
	jr z, binInput_one
	cp k0
	jr nz, binInputloop						;else unaccepted keypress, so reloop
binInput_zero:
	ld a, 48							;char code for '0'
	ld (hl), a							;save it
	inc hl								;next location
	call _putc							;display a zero
	djnz binInputloop					;reloop until full 8 chars input
	jr binInputdone
binInput_one:
	ld a, 49							;char code '1'
	ld (hl), a
	inc hl
	call _putc
	djnz binInputloop
binInputdone:							;done inputting this 8 bits.
	ld hl, $FA00
	ld c, 0
	ld a, 48							;char code for zero
	cp (hl)
	jr z, binbit6						;bit seven is a zero, so skip
	ld c, 128							;storing number in c
binbit6:
	inc hl
	cp (hl)
	jr z, binbit5
	ld a, 64
	add a, c
	ld c, a
	ld a, 48
binbit5:
	inc hl
	cp (hl)
	jr z, binbit4
	ld a, 32
	add a, c
	ld c, a
	ld a, 48
binbit4:
	inc hl
	cp (hl)
	jr z, binbit3
	ld a, 16
	add a, c
	ld c, a
	ld a, 48
binbit3:
	inc hl
	cp (hl)
	jr z, binbit2
	ld a, 8
	add a, c
	ld c, a
	ld a, 48
binbit2:
	inc hl
	cp (hl)
	jr z, binbit1
	ld a, 4
	add a, c
	ld c, a
	ld a, 48
binbit1:
	inc hl
	cp (hl)
	jr z, binbit0
	inc c
	inc c
binbit0:
	inc hl
	cp (hl)
	jr z, binbitdone
	inc c
binbitdone:
	ld a, c
	ret
	
	









;------------------------------------------------------------------------------------------------------
;AtoDEC-- A to DECimal.  Displays number in a as decimal number up to 255.  All leading zeroes trimmed.
;by Cassady Roop
;------------------------------------------------------------------------------------------------------
AtoDEC:
      ld h, 0
	ld l, a
      ld b, 3
      ld de, num_spot+2
atodecmain:
      call _hldiv10   		
      add a, 48       		;convert to char code
      ld (de), a       		;store it to temp space
      dec de
      djnz atodecmain
      ld hl, num_spot
	xor a
	add a, 48			;char code for zero
	cp (hl)
	jr nz, atodecdisp
	inc hl
	cp (hl)
	jr nz, atodecdisp
	inc hl
atodecdisp:
      call _vputs     		;display it at current pen coords
      ret




Quit:
	call _homeup
	call _clrlcd
	call textblank
	ret


titletext:
	.db "IPwizard 1.3",0
credittext:
	.db "by Cassady Roop",0
classtext:
	.db "Class ",0
quittext:
	.db "Quit",0
IPtext:
	.db "IP:",0
dectobintext:
	.db "DEC",$05,"B",0				;'DEC>B'
bintodectext:
	.db "BIN",$05,"D",0				;'BIN>D'

.end
